<template>
  <div>
    <div class="mainPage"><top-menu /></div>
    <div class="q-pl-md q-pt-md">
      <q-btn label="Add user" outline @click="addNewUserBtn()" />
    </div>
    <div class="q-pa-md">
      <q-table
        :data="data"
        :pagination.sync="pagination"
        :columns="columns"
        flat
        bordered
      >
        <template v-slot:body="props">
          <q-tr :props="props">
            <q-td key="no" :props="props" style="width: 50px">{{
              props.row.no
            }}</q-td>
            <q-td key="username" :props="props">{{ props.row.username }}</q-td>
            <q-td key="password" :props="props">{{ props.row.password }}</q-td>
            <q-td key="examinee" :props="props" style="width: 120px"
              ><div v-if="props.row.examinee == 1">
                <q-icon name="fas fa-check" />
              </div>
              <div v-else><q-icon name="fas fa-times" /></div>
            </q-td>
            <q-td key="examination" :props="props" style="width: 120px"
              ><div v-if="props.row.examination == 1">
                <q-icon name="fas fa-check" />
              </div>
              <div v-else><q-icon name="fas fa-times" /></div>
            </q-td>
            <q-td key="user" :props="props" style="width: 120px"
              ><div v-if="props.row.user == 1">
                <q-icon name="fas fa-check" />
              </div>
              <div v-else><q-icon name="fas fa-times" /></div>
            </q-td>
            <q-td key="edit" :props="props" style="width: 100px">
              <div
                class="q-py-sm cursor-pointer"
                @click="editUser(props.row.id)"
              >
                <u>edit</u>
              </div>
            </q-td>
            <q-td key="delete" :props="props" style="width: 100px">
              <div
                class="q-py-sm cursor-pointer"
                @click="delUser(props.row.id)"
              >
                <u>delete</u>
              </div>
            </q-td>
          </q-tr>
        </template>
      </q-table>
    </div>
    <!-- Add dialog -->
    <q-dialog v-model="addUserDialog">
      <q-card class="user-dialog q-pa-md">
        <div class="text-h6">Add User</div>
        <div class="row q-px-xl q-pt-md">
          <div class="user-add-label">Username</div>
          <div class="col">
            <q-input v-model="input.username" outlined dense />
          </div>
        </div>
        <div class="row q-px-xl q-pt-md">
          <div class="user-add-label">Password</div>
          <div class="col">
            <q-input v-model="input.password" outlined dense />
          </div>
        </div>
        <div class="row q-px-xl">
          <div class="col-4">
            <q-checkbox v-model="input.examinee" disable label="Examinee" />
          </div>
          <div class="col-4">
            <q-checkbox v-model="input.examination" label="Examination" />
          </div>
          <div class="col-4">
            <q-checkbox v-model="input.user" label="User" />
          </div>
        </div>
        <div class="row q-pt-md justify-center">
          <div>
            <q-btn
              label="Cancel"
              outline
              class="short-btn"
              @click="closeAddUserDialog()"
            />
          </div>
          <div style="width: 15px"></div>
          <div>
            <q-btn
              label="Save"
              class="short-btn active-btn"
              @click="saveAddNew()"
            />
          </div>
        </div>
      </q-card>
    </q-dialog>
    <!-- Edit dialog -->
    <q-dialog v-model="editUserDialog">
      <q-card class="user-dialog q-pa-md">
        <div class="text-h6">Edit User</div>
        <div class="row q-px-xl q-pt-md">
          <div class="user-add-label">Username</div>
          <div class="col">
            <q-input v-model="input.username" outlined dense />
          </div>
        </div>
        <div class="row q-px-xl q-pt-md">
          <div class="user-add-label">Password</div>
          <div class="col">
            <q-input v-model="input.password" outlined dense />
          </div>
        </div>
        <div class="row q-px-xl">
          <div class="col-4">
            <q-checkbox v-model="input.examinee" label="Examinee" disable />
          </div>
          <div class="col-4">
            <q-checkbox v-model="input.examination" label="Examination" />
          </div>
          <div class="col-4">
            <q-checkbox v-model="input.user" label="User" />
          </div>
        </div>
        <div class="row q-pt-md justify-center">
          <div>
            <q-btn
              label="Cancel"
              outline
              class="short-btn"
              @click="closeEditUserDialog()"
            />
          </div>
          <div style="width: 15px"></div>
          <div>
            <q-btn
              label="Save"
              class="short-btn active-btn"
              @click="saveEditNew()"
            />
          </div>
        </div>
      </q-card>
    </q-dialog>
    <!-- alert delete dialog  -->
    <q-dialog v-model="deluserDialog" persistent>
      <q-card>
        <q-card-section>
          <div class="titleDialog">Delete user</div>

          <hr style="width: 400px" />
          <div align="center">
            <div>Do you want to delete this user?</div>
          </div>
        </q-card-section>
        <q-card-actions align="center">
          <div class="row">
            <q-btn
              label="Cancel"
              outline
              class="short-btn"
              @click="closeDelDia()"
            />

            <div style="width: 15px"></div>
            <q-btn
              label="Yes"
              class="short-btn active-btn"
              @click="confirmDelBtn()"
            />
          </div>
        </q-card-actions>
        <br />
      </q-card>
    </q-dialog>
  </div>
</template>

<script>
import axios from "axios";
import topMenu from "../components/topmenu.vue";
export default {
  components: {
    topMenu,
  },
  data() {
    return {
      input: {
        id: 0,
        username: "",
        password: "",
        examinee: true,
        examination: false,
        user: false,
      },
      addUserDialog: false,
      editUserDialog: false,
      deluserDialog: false,
      delId: 0,
      pagination: {
        rowsPerPage: 50,
      },
      columns: [
        {
          name: "no",
          label: "no",
          align: "center",
        },
        { name: "username", label: "username", align: "center" },
        { name: "password", label: "password", align: "center" },
        { name: "examinee", label: "examinee", align: "center" },
        { name: "examination", label: "examination", align: "center" },
        { name: "user", label: "user", align: "center" },
        { name: "edit", label: "edit", align: "center" },
        { name: "delete", label: "delete", align: "center" },
      ],
      data: [],
    };
  },
  methods: {
    async confirmDelBtn() {
      let dataSend = {
        id: this.delId,
      };
      let url = this.serverpath + "deleteadmin.php";
      let res = await axios.post(url, JSON.stringify(dataSend));
      if (res.data == "finish") {
        this.greenNotify("delete complete");
        this.loadUser();
      } else {
        this.redNotify("delete incomplete");
      }
      this.deluserDialog = false;
    },
    closeDelDia() {
      this.deluserDialog = false;
    },
    delUser(id) {
      this.deluserDialog = true;
      this.delId = id;
    },
    async saveEditNew() {
      if (this.input.username.length >= 6 && this.input.password.length >= 6) {
        let url = this.serverpath + "editadmin.php";
        let res = await axios.post(url, JSON.stringify(this.input));
        if (res.data == "finish") {
          this.greenNotify("save complete");
          this.loadUser();
        } else {
          this.redNotify("save incomplete");
        }

        this.editUserDialog = false;
      } else {
        this.redNotify("Username and password must be at least 6 characters.");
      }
    },
    closeEditUserDialog() {
      this.editUserDialog = false;
    },
    editUser(id) {
      this.editUserDialog = true;
      let dataEdit = this.data.filter((x) => x.id == id);
      this.input.username = dataEdit[0].username;
      this.input.password = dataEdit[0].password;
      this.input.examinee = dataEdit[0].examinee == 1 ? true : false;
      this.input.examination = dataEdit[0].examination == 1 ? true : false;
      this.input.user = dataEdit[0].user == 1 ? true : false;
      this.input.id = dataEdit[0].id;
    },
    async saveAddNew() {
      if (this.input.username.length >= 6 && this.input.password.length >= 6) {
        let url = this.serverpath + "addnewadmin.php";
        let res = await axios.post(url, JSON.stringify(this.input));
        if (res.data == "finish") {
          this.greenNotify("save complete");
        } else {
          this.redNotify("save incomplete");
        }

        this.addUserDialog = false;
      } else {
        this.redNotify("Username and password must be at least 6 characters.");
      }
    },
    addNewUserBtn() {
      this.input.username = "";
      this.input.password = "";
      this.input.examinee = true;
      this.input.examination = false;
      this.input.user = false;
      this.addUserDialog = true;
    },
    closeAddUserDialog() {
      this.addUserDialog = false;
    },
    async loadUser() {
      let key = this.$q.localStorage.getItem("key");
      let dataSend = { key: key };
      let url = this.serverpath + "loadadmin.php";
      let res = await axios.post(url, JSON.stringify(dataSend));
      if (res.data == "go to examinee") {
        this.$router.push("/examinee");
      } else if (res.data == "go to login") {
        this.$q.localStorage.clear();
        this.$router.push("/");
      } else {
        this.data = res.data;
        this.data.forEach((item, index) => {
          item.no = index + 1;
        });
      }
    },
  },
  mounted() {
    this.loadUser();
  },
};
</script>

<style lang="scss" scoped>
.user-dialog {
  min-width: 650px;
  height: 280px;
}
.user-add-label {
  width: 120px;
  padding-top: 10px;
}
</style>
